"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Selectbox = void 0;
const react_1 = __importStar(require("react"));
const ramda_1 = require("ramda");
const react_native_1 = require("react-native");
const react_native_unistyles_1 = require("react-native-unistyles");
const AngleDown_1 = require("@procyon/components/Icons/AngleDown");
const AngleUp_1 = require("@procyon/components/Icons/AngleUp");
const Backspace_1 = require("@procyon/components/Icons/Backspace");
const List_1 = require("@procyon/components/List");
const debounce_1 = require("@procyon/utils/debounce");
const TextField_1 = require("./TextField");
const Selectbox = (props) => {
    var _a, _b, _c, _d;
    const { value, options, onChange, name, label } = props, others = __rest(props, ["value", "options", "onChange", "name", "label"]);
    const { styles } = (0, react_native_unistyles_1.useStyles)(stylesheet);
    const [searchTerm, setSearchTerm] = (0, react_1.useState)(null);
    const [selected, setSelected] = (0, react_1.useState)();
    const [opened, setOpened] = (0, react_1.useState)(false);
    (0, react_1.useEffect)(() => {
        if (value !== (selected === null || selected === void 0 ? void 0 : selected.id)) {
            const newOption = options === null || options === void 0 ? void 0 : options.find(({ id }) => id === value);
            if (newOption) {
                setSelected(newOption);
            }
        }
    }, [value, options]);
    const handleChoose = (id) => {
        const newOption = options.find((option) => option.id === id);
        setSelected(newOption);
        setSearchTerm(null);
        setOpened(false);
        onChange === null || onChange === void 0 ? void 0 : onChange(newOption === null || newOption === void 0 ? void 0 : newOption.id);
    };
    const handleToggle = () => {
        setOpened((opened) => !opened);
    };
    const handleSearch = (0, debounce_1.debounceAfter)((value) => {
        setSearchTerm(value);
    }, 200);
    const handleClear = () => {
        setSearchTerm(null);
        setSelected(null);
        onChange === null || onChange === void 0 ? void 0 : onChange(null);
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(TextField_1.TextField, Object.assign({}, others, { style: (_a = props.style) === null || _a === void 0 ? void 0 : _a.input, name: name, onChange: handleSearch, label: label, value: searchTerm !== null && searchTerm !== void 0 ? searchTerm : selected === null || selected === void 0 ? void 0 : selected.name, onFocus: () => setOpened(true), LeftIcon: (props) => (react_1.default.createElement(react_native_1.Pressable, Object.assign({ onPress: handleToggle, style: [styles.procyon_selectbox_icon] }, props), opened ? react_1.default.createElement(AngleUp_1.AngleUpIcon, null) : react_1.default.createElement(AngleDown_1.AngleDownIcon, null))), RightIcon: (props) => (react_1.default.createElement(react_native_1.Pressable, Object.assign({ onPress: handleClear, style: [styles.procyon_selectbox_icon] }, props),
                react_1.default.createElement(Backspace_1.BackspaceIcon, Object.assign({}, styles.procyon_selectbox_crossIcon)))) })),
        opened && (react_1.default.createElement(react_native_1.View, { style: styles.procyon_selectbox_list_parent_container },
            react_1.default.createElement(List_1.List, { options: options.filter((option) => !searchTerm
                    ? options
                    : option.name.toLowerCase().includes(searchTerm.toLowerCase())), selectedId: (_b = selected === null || selected === void 0 ? void 0 : selected.id) !== null && _b !== void 0 ? _b : undefined, onClick: handleChoose, style: (0, ramda_1.mergeDeepRight)({
                    container: [
                        styles.procyon_selectbox_list_container,
                        (_c = props.style) === null || _c === void 0 ? void 0 : _c.container,
                    ],
                }, (_d = props.style) !== null && _d !== void 0 ? _d : {}) })))));
};
exports.Selectbox = Selectbox;
const stylesheet = (0, react_native_unistyles_1.createStyleSheet)((theme) => ({
    procyon_selectbox_icon: Object.assign({}, { cursor: 'pointer' }),
    procyon_selectbox_crossIcon: {
        color: theme.components.field.error.border,
    },
    procyon_selectbox_list_parent_container: {
        position: 'relative',
        zIndex: 1,
    },
    procyon_selectbox_list_container: {
        maxHeight: 250,
        position: 'absolute',
        width: 'calc(100% - 8px)',
    },
}));
