"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextField = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const react_native_unistyles_1 = require("react-native-unistyles");
const FieldMessage_1 = require("@procyon/components/FieldMessage");
const enums_1 = require("@procyon/types/enums");
const masker_1 = require("@procyon/utils/masker");
const Label_1 = require("./Label");
const Skeleton_1 = require("./Skeleton");
const TextField = (props) => {
    var _a;
    const { mode = 'text', onClick, onFocus, onBlur, onChange, disabled = false, name, label, status = enums_1.StatusEnum.none, autoFocus, mask, placeholder, multiline, LeftIcon, RightIcon, leftText, rightText, message, style, readonly, size = enums_1.SizeEnum.md, secret, loading, } = props;
    const [value, setValue] = (0, react_1.useState)('');
    const { styles, theme } = (0, react_native_unistyles_1.useStyles)(styleSheet, {
        disabled,
        status,
        size,
    });
    (0, react_1.useEffect)(() => {
        setValue(applyMask(props.value));
    }, [props.value]);
    const applyMask = (val) => {
        if (mask && val) {
            return masker_1.masker.toPattern(val.toString(), mask);
        }
        return val;
    };
    const handleClick = (e) => {
        onClick === null || onClick === void 0 ? void 0 : onClick(value, e);
    };
    const handleFocus = (e) => {
        onFocus === null || onFocus === void 0 ? void 0 : onFocus(value, e);
    };
    const handleBlur = (e) => {
        onBlur === null || onBlur === void 0 ? void 0 : onBlur(value, e);
    };
    const handleChange = (e) => {
        const value = e.nativeEvent.text;
        const masked = applyMask(value);
        setValue(masked);
        if (onChange) {
            onChange(masked, e);
        }
    };
    return (react_1.default.createElement(react_native_1.View, { style: [styles.procyon_textField_container, style === null || style === void 0 ? void 0 : style.container], "aria-label": "textfield" },
        react_1.default.createElement(Label_1.Label, { label: label }),
        react_1.default.createElement(react_native_1.View, { style: { display: 'flex', flexDirection: 'row' } },
            react_1.default.createElement(Skeleton_1.Skeleton, { active: loading || false, layout: [{ key: '1', height: 40 }] },
                LeftIcon && (react_1.default.createElement(react_native_1.View, { style: [
                        styles.procyon_textField_icon_container('left', 'icon'),
                        style === null || style === void 0 ? void 0 : style.icon,
                    ] },
                    react_1.default.createElement(LeftIcon, { style: styles.procyon_textField_icon() }))),
                leftText && (react_1.default.createElement(react_native_1.View, { style: [
                        styles.procyon_textField_icon_container('left', 'text'),
                        style === null || style === void 0 ? void 0 : style.icon,
                    ] },
                    react_1.default.createElement(react_native_1.Text, { style: styles.procyon_textField_icon() }, leftText))),
                react_1.default.createElement(react_native_1.TextInput, { style: [
                        styles.procyon_textField_input({
                            leftSide: !!LeftIcon || !!leftText,
                            rightSide: !!RightIcon || !!rightText,
                        }),
                        style === null || style === void 0 ? void 0 : style.input,
                    ], id: name, secureTextEntry: secret, inputMode: mode, onPressIn: handleClick, onFocus: handleFocus, onBlur: handleBlur, onChange: handleChange, autoFocus: autoFocus, readOnly: readonly || disabled, value: value !== null && value !== void 0 ? value : '', multiline: multiline, placeholder: placeholder, placeholderTextColor: theme.components.field.disabled.color, numberOfLines: ((_a = value === null || value === void 0 ? void 0 : value.match(/\n/g)) !== null && _a !== void 0 ? _a : []).length + 1, autoComplete: "off" }),
                RightIcon && (react_1.default.createElement(react_native_1.View, { style: [
                        styles.procyon_textField_icon_container('right', 'icon'),
                        style === null || style === void 0 ? void 0 : style.icon,
                    ] },
                    react_1.default.createElement(RightIcon, { style: styles.procyon_textField_icon() }))),
                rightText && (react_1.default.createElement(react_native_1.View, { style: [
                        styles.procyon_textField_icon_container('right', 'text'),
                        style === null || style === void 0 ? void 0 : style.icon,
                    ] },
                    react_1.default.createElement(react_native_1.Text, { style: styles.procyon_textField_icon() }, rightText))))),
        react_1.default.createElement(FieldMessage_1.FieldMessage, { message: message, status: status, size: size })));
};
exports.TextField = TextField;
const styleSheet = (0, react_native_unistyles_1.createStyleSheet)((theme) => {
    return {
        procyon_textField_container: {
            padding: theme.spacing.sm,
        },
        procyon_textField_input: ({ leftSide, rightSide, }) => {
            const variantForStatus = (status) => ({
                borderColor: theme.components.field[status].border,
            });
            const variantForSize = (size) => ({
                padding: theme.spacing[size],
                fontSize: theme.fontSize[size],
            });
            return {
                flex: 1,
                color: theme.components.field.input.color,
                backgroundColor: theme.components.field.input.background,
                borderWidth: 2,
                fontFamily: theme.fontFamily,
                borderRadius: theme.spacing.md,
                borderTopLeftRadius: leftSide ? 0 : theme.spacing.md,
                borderBottomLeftRadius: leftSide ? 0 : theme.spacing.md,
                borderLeftWidth: leftSide ? 0 : undefined,
                borderTopRightRadius: rightSide ? 0 : theme.spacing.md,
                borderBottomRightRadius: rightSide ? 0 : theme.spacing.md,
                borderRightWidth: rightSide ? 0 : undefined,
                variants: {
                    disabled: {
                        true: {
                            color: theme.components.field.disabled.color,
                        },
                    },
                    status: {
                        [enums_1.StatusEnum.none]: variantForStatus(enums_1.StatusEnum.none),
                        [enums_1.StatusEnum.info]: variantForStatus(enums_1.StatusEnum.info),
                        [enums_1.StatusEnum.success]: variantForStatus(enums_1.StatusEnum.success),
                        [enums_1.StatusEnum.warning]: variantForStatus(enums_1.StatusEnum.warning),
                        [enums_1.StatusEnum.error]: variantForStatus(enums_1.StatusEnum.error),
                    },
                    size: {
                        [enums_1.SizeEnum.sm]: variantForSize(enums_1.SizeEnum.sm),
                        [enums_1.SizeEnum.md]: variantForSize(enums_1.SizeEnum.md),
                        [enums_1.SizeEnum.lg]: variantForSize(enums_1.SizeEnum.lg),
                        [enums_1.SizeEnum.xl]: variantForSize(enums_1.SizeEnum.xl),
                    },
                },
            };
        },
        procyon_textField_icon_container: (position, type) => {
            const variantForStatus = (status) => ({
                borderColor: theme.components.field[status].border,
            });
            const variantForSize = (size) => ({
                fontSize: theme.fontSize[size] + (type === 'icon' ? 4 : 0),
            });
            return Object.assign(Object.assign(Object.assign(Object.assign({ borderWidth: 2 }, (type === 'icon'
                ? {
                    justifyContent: 'center',
                }
                : {})), (position === 'left'
                ? {
                    borderTopLeftRadius: theme.spacing.md,
                    borderBottomLeftRadius: theme.spacing.md,
                }
                : {})), (position === 'right'
                ? {
                    borderTopRightRadius: theme.spacing.md,
                    borderBottomRightRadius: theme.spacing.md,
                }
                : {})), { variants: {
                    status: {
                        [enums_1.StatusEnum.none]: variantForStatus(enums_1.StatusEnum.none),
                        [enums_1.StatusEnum.info]: variantForStatus(enums_1.StatusEnum.info),
                        [enums_1.StatusEnum.success]: variantForStatus(enums_1.StatusEnum.success),
                        [enums_1.StatusEnum.warning]: variantForStatus(enums_1.StatusEnum.warning),
                        [enums_1.StatusEnum.error]: variantForStatus(enums_1.StatusEnum.error),
                    },
                    size: {
                        [enums_1.SizeEnum.sm]: variantForSize(enums_1.SizeEnum.sm),
                        [enums_1.SizeEnum.md]: variantForSize(enums_1.SizeEnum.md),
                        [enums_1.SizeEnum.lg]: variantForSize(enums_1.SizeEnum.lg),
                        [enums_1.SizeEnum.xl]: variantForSize(enums_1.SizeEnum.xl),
                    },
                } });
        },
        procyon_textField_icon: () => {
            const variantForStatus = (status) => ({
                color: status === enums_1.StatusEnum.none
                    ? theme.components.field.icon.color
                    : theme.components.field[status].border,
            });
            const variantForSize = (size) => ({
                padding: theme.spacing[size] + 2,
            });
            return {
                fontFamily: theme.fontFamily,
                variants: {
                    disabled: {
                        true: {
                            color: theme.components.field.disabled.color,
                        },
                    },
                    status: {
                        [enums_1.StatusEnum.none]: variantForStatus(enums_1.StatusEnum.none),
                        [enums_1.StatusEnum.info]: variantForStatus(enums_1.StatusEnum.info),
                        [enums_1.StatusEnum.success]: variantForStatus(enums_1.StatusEnum.success),
                        [enums_1.StatusEnum.warning]: variantForStatus(enums_1.StatusEnum.warning),
                        [enums_1.StatusEnum.error]: variantForStatus(enums_1.StatusEnum.error),
                    },
                    size: {
                        [enums_1.SizeEnum.sm]: variantForSize(enums_1.SizeEnum.sm),
                        [enums_1.SizeEnum.md]: variantForSize(enums_1.SizeEnum.md),
                        [enums_1.SizeEnum.lg]: variantForSize(enums_1.SizeEnum.lg),
                        [enums_1.SizeEnum.xl]: variantForSize(enums_1.SizeEnum.xl),
                    },
                },
            };
        },
    };
});
